# Deploy Stellio

This document describes how to deploy Stellio on the platform using the Ansible Playbook. 

The following components will be deployed:

- Stellio API Gateway
- Stellio Search Service
  - Core and Temporal API
- Stellio Subscription Service
  - Subscription API
- Kafka
  - Stellio streaming engine
- PostgreSQL
  - Database for Stellio
  - Either from Helm Chart or from the platform's Postgres Operator.

## Step 1: Add Stellio to inventory

- Copy and paste the following into the inventory file under `inv_am`: 
```yaml
stellio:
    enable: "true"
    ns_create: "true"
    ns_name: "{{ ENVIRONMENT }}-ngsi-stack"
    ns_kubeconfig: "{{ kubeconfig_file }}"
    use_postgres_operator: false
    postgres_credentials: # Only needed if use_postgres_operator is false
        username: "stellio"
        password: ""
```

## Step 2: Set PostgreSQL settings

- Decide whether the deployment of Stellio should be with the Helm Chart native deployment or with the platform's Postgres Operator. 
  - PLEASE NOTE: The Postgres Operator must be running with a Spilo image which supports Postgres 14 with the extensions `TimescaleDB` and `PostGIS`.
- If the Postgres Operator is used, set `use_postgres_operator` to `true` and skip to step 4.
- If the Helm Chart native PostgreSQL is used, set `use_postgres_operator` to `false` and set the `postgres_credentials` with the username and password for the database.
  - Make sure the password for PostgreSQL does not contain characters that are not allowed in a PostgreSQL password. This could lead to for example an `EOF error` and the PostgreSQL instance will not start.
  - Looking at the autogenerated passwords from the Postgres Operator, it does seem like that most special characters are not allowed, as the passwords contain only letters and numbers. They are instead just long passwords, usually at around 64 characters.

## Step 3: Add replica variables to inventory
- Copy and paste the following into the inventory file under `inv_replicas`:
```yaml
cm:
    api_gateway: 1
    kafka: 1
    postgresql: 1
    search_service: 1
    subscription_service: 1
```
- Set the replicas according to the needs of the deployment.

## Step 4: Run the playbook

- Run the playbook with the following command and tag:
```bash
ansible-playbook -l localhost -i inventory.yml 02_core_platform/full_install.yml --tags "cm_stellio"
```